/* ------< ip_filter.c >------< 2019.05.17 >------------------------------------ */
/*	ip_filter ( ver=1.01 ) : Create the deny lists for apache.               */
/*										 */
/* Copyright (C) kamifuji@kamifuji.dyndns.org     2019-2019  All rights reserved.*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
// #include <sys/dirent.h>
#include <time.h>
#include <utime.h>
#include <pwd.h>
#include <grp.h>
#include <dirent.h>
#define	LF	0x0a
#define	CR	0x0d

extern char *optarg;
extern int optind, opterr;

enum { CR_NONE, CR_DOS, CR_UNIX, CR_MAC } cr_type;
char *program = NULL;
long long m_sum ;


void perror2(char *prg ,char *fname ) {
	printf("%s : File open error ( %s )\n" ,prg ,fname );
}


int tab_spc(int spcs ,unsigned char *buff)
{
    int i ,j ,n ,np ;
    unsigned char work[2048] ;


    n = strlen(buff);
    if (n > 2047) {
      n = 2047 ;
    }

    memcpy(work ,buff ,n);
    work[n] = 0 ;

    j = 0 ;
    for (i = 0 ; i < n ; i++ ) {
      if (work[i] == 0x09) {
	np = (j + spcs)/spcs * spcs ;
	for ( ; j < np ; j++) {
	  buff[j] = ' ' ;
        }
      }
      else {
	buff[j] = work[i] ;
	j++ ;
      }

      if ( j > 2047 ) {
	break ;
      }

    }
    buff[j] = 0 ;

    return(j) ;

}


int max_col( char *fname )
{
    char ret[1024] ;
    int i ,clm ;
    FILE *fp ;

    clm = 0 ;

    if (( fp = fopen( fname ,"r" )) == NULL) {
      perror2( program, fname );
      return(-1);
    }
    while (1) {
      if ( fgets( ret ,1024 ,fp ) == NULL ) {
	break ;
      }
      i = strlen ( ret );
      if ( i > clm ) {
	clm = i ;
      }
    }
    fclose( fp );

    return(clm);

}


int get_line( char *fname ,int nLine ,char *ret )
{
    int i ,rf ;
    FILE *fp ;

    i = 0 ;
    strcpy( ret ,"" );

    if (( fp = fopen( fname ,"r" )) == NULL) {
      perror2( program, fname );
      return(-1);
    }
    while (1) {
      if ( fgets( ret ,1024 ,fp ) == NULL ) {
	rf = -2 ;
	break ;
      }
      i++ ;
      if ( i == nLine ) {
	rf = 0 ;
	break ;
      }
    }
    fclose( fp );

    return(rf);

}


int CSVDiv( char *csvData ,char **divData ,char del )
{
	int i ,j ,k ,n ;
	char cr ,cb ,cf ;

	i = 0 ;
	n = strlen( csvData );
	j = 0 ;
	k = 0 ;
	divData[k] = &csvData[i] ; k++ ;
	while ( ( i < n ) && ( k < 256 ) ) {
		if ( csvData[i] == '\"' ) {
			i++ ;
			while ( i < n ) {
				cb = csvData[i - 1] ;
				cr = csvData[i] ;
				cf = csvData[i + 1] ;
				if ( ( cr == '\"' ) && ( cf == '\"' ) ) {
					i++ ;
				}
				else if ( ( cr == '\"' ) && ( cb != '\\' ) ) {
					break ;
				}
				i++ ;
			}
		}
		else if ( csvData[i] == del ) {
			csvData[i] = 0 ;
			j = i + 1 ;
			divData[k] = &csvData[j] ; k++ ;
		}
		i++ ;
	}

	if ( n - j ) {
		divData[k] = &csvData[j] ; k++ ;
	}

	return ( k );

}


int CreateDenyList( FILE *wrt ,char *m_cc ,char *txtInPath )
{
	FILE *Red ;
	char szWork[1024] ,buff[1024] ,cstr[256] ,*divData[256] ;
	int np ,nl ,nclm ,msk ,ns ;
//	long long ns ;
	double dns ;

	strcpy( cstr ,"|" );
	strcat( cstr ,m_cc );
	strcat( cstr ,"|ipv4|" );

	if (( Red = fopen( txtInPath ,"r" )) == NULL) {
		perror2( program, txtInPath );
		return (-1);
	}

	nl = 0 ;
	while (1) {
		if ( fgets( buff ,1024 ,Red ) == NULL ) {
			break ;
		}
		np = strpos( buff ,cstr );
		if ( np ) {
//			fprintf( wrt ,"%s" ,buff );
			nclm = CSVDiv( buff ,divData ,'|' );
			ns = atoi( divData[4] );
			dns = (double)ns ;
			msk = 32 - (int)( log2(dns) / log2(2.0) );
			fprintf( wrt ,"    Deny from %s/%d\n" ,divData[3] ,msk );
			m_sum += ns ;

			nl++ ;
		}
	}

	fprintf( wrt ,"    # cc_name : %s   m_sum :  %d\n" ,m_cc ,m_sum );
	fclose( Red );

	return(nl);

}


/*
int diff_cal( base_file ,new_file ,diff_file ,kdiff_file ,html_file )
  char *base_file ,*new_file ,*diff_file ,*kdiff_file ;
  char *html_file ;
  {
    int i ,j ,k ,nl ,nlb ,nln ,toln ,bp ,np ,bpw ,npw ,dp ,cw ,chkF ;
    int add_lines ,del_lines ,change_base ,change_new ,diff_lines ;
    int cmntLine_base ,cmntLine_new ;
    int change_cmnt ,max_base ,max_new ,dpos[5] ;
    unsigned long nWrt ;
    char diff_str[1024] ,work[8192] ,bwork[2048] ,nwork[2048] ;
    char base_str[1024] ,new_str[1024] ,chk_str[1024] ,tstr[1024] ;
    FILE *diff ,*kdiff ,*html ,*sh ;


    if (( html = fopen( html_file ,"w" )) == NULL) {
      perror2( program, html_file );
      return (-1);
    }

    if (( kdiff = fopen( kdiff_file ,"w" )) == NULL) {
      perror2( program, kdiff_file );
      return (-1);
    }

    if (( diff = fopen( diff_file ,"r" )) == NULL) {
      perror2( program, diff_file );
      return (-1);
    }

    sprintf( tstr ,"%s // %s" ,base_file ,new_file );
    out_html_head( html ,tstr );

    fprintf( html ,"<tr><td class=\"h3\">%s</td><td>&nbsp;&nbsp;#&nbsp;&nbsp;</td><td class=\"h3\">%s</td></tr>\n" ,base_file ,new_file );

    fprintf( html ,"<tr><td class=\"w\">.</td><td> </td><td class=\"w\"> </td></tr>\n" );


    add_lines = 0 ;
    del_lines = 0 ;
    change_base = 0 ;
    change_new = 0 ;
    change_cmnt = 0 ;
    diff_lines = 0 ;

    max_base = max_col( base_file );
    max_new = max_col( new_file );
    if ( max_base > max_new ) {
	max_new = max_base ;
    }
    else {
	max_base = max_new ;
    }

    dp = 0 ;
    bp = 1 ;
    np = 1 ;
    bpw = 1 ;
    npw = 1 ;
    cw = 1 ;
    while (1) {
      if ( fgets( diff_str ,1024 ,diff ) == NULL ) {
	break ;
      }
    }

    fprintf( html ,"<tr><td class=\"w\">%s</td><td> </td><td class=\"w\"> </td></tr>\n" ,bwork );
    fprintf( html ,"<tr><td class=\"w\">------------------------</td><td> </td><td class=\"w\"> </td></tr>\n" );

    out_html_end( html );

    fclose( diff );
    fclose( kdiff );
    fclose( html );

  }
*/

int main(int argc, char **argv, char **envp)
{
    int i ,n ,ret ;
    FILE *wrt ;
    char m_txtOutPath[1024] ;
    char m_cc[8] ;
    char m_txtInPath[256][1024] ;

//    char base_file[512] ,new_file[512] ,diff_file[512] ;
//    char kdiff_file[512] ,html_file[512] ,ps_file[512] ,work[1024] ;
//    char base_str[1024] ,new_str[1024] ;
  

    program = argv[0];

    if ( (argc < 3) || ((argc >= 2) && (strcmp(argv[1] ,"-h") == 0)) ) {
      fprintf(stderr ,"Usage : %s CC ,fname1 ,fname2 , .....\n" ,program);
      exit(0);
    }

    strcpy( m_cc ,argv[1] );
    n = 0 ;

    for ( i = 2 ; i < argc ; i++ ) {
	strcpy( m_txtInPath[i - 2] ,argv[i] );
	n++ ;
    }

    strcpy( m_txtOutPath ,"_" );
    strcat( m_txtOutPath ,m_cc );
    strcat( m_txtOutPath ,".deny" );
    m_sum = 0 ;

    if (( wrt = fopen( m_txtOutPath ,"w" )) == NULL) {
      perror2( program, m_txtOutPath );
      exit(-1);
    }

    fprintf( stdout ,"m_ccc : ( %s )\n" ,m_cc );

    for ( i = 0 ; i < n ; i++ ) {
	fprintf( stdout ,"%d : ( %s )\n" ,i ,m_txtInPath[i] );
	ret = CreateDenyList( wrt ,m_cc ,m_txtInPath[i] );
	fprintf( stdout ,"%d found.\n" ,ret );
    }

    fclose( wrt );

    exit(0);

  }


